Object subclass: #Club
	instanceVariableNames: 'nombre tarifaSocio tarifaVIP recaudacion socios'
	classVariableNames: ''
	package: 'tp0.5-Modelo'!

!Club methodsFor: 'initialization' stamp: 'SilverWerewolf 4/28/2020 23:08'!
initialize
	recaudacion := 0.
	socios := OrderedCollection new.! !


!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 23:11'!
agregarSocio: unSocio
	socios add: unSocio.
	unSocio asignarTarifa: tarifaSocio.! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/29/2020 00:40'!
buscarSocio: nombreSocio
	^socios detect: [:socio | socio obtenerNombre = nombreSocio].
	! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 23:54'!
nombresSocios
	^Set withAll: (socios collect: [:socio |socio obtenerNombre]).! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/29/2020 00:10'!
cantidadDeSocios
	^socios size.! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 22:33'!
establecerNombre: unNombre
	nombre := unNombre. ! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/29/2020 00:48'!
cantidadPagadaPor: nombreSocio
	| socioEncontrado |
	socioEncontrado := self buscarSocio: nombreSocio.
	^socioEncontrado obtenerGastado.! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 22:36'!
establecerTarifaSocioVIP: unaTarifa
	tarifaVIP := unaTarifa .! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 22:35'!
establecerTarifaSocio: unaTarifa
	tarifaSocio := unaTarifa.! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 23:13'!
agregarSocioVIP: unSocio
	socios add: unSocio.
	unSocio asignarTarifa: tarifaVIP.! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/29/2020 00:43'!
recibirPagoDe: nombreSocio
	| socioABuscar |
	socioABuscar := self buscarSocio: nombreSocio.
	recaudacion := recaudacion + socioABuscar pagarTarifa.! !

!Club methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 22:39'!
recaudacionTotal
	^recaudacion.! !


Object subclass: #Socio
	instanceVariableNames: 'nombre tarifa pagado'
	classVariableNames: ''
	package: 'tp0.5-Modelo'!

!Socio methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 23:06'!
asignarTarifa: unaTarifa
	tarifa := unaTarifa.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/29/2020 00:33'!
pagarTarifa
	pagado := pagado + tarifa.
	^tarifa.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 22:41'!
establecerNombre: unNombre
	nombre := unNombre.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/28/2020 23:47'!
obtenerNombre
	^nombre.! !

!Socio methodsFor: 'as yet unclassified' stamp: 'SilverWerewolf 4/29/2020 00:46'!
obtenerGastado
	^pagado.! !


!Socio methodsFor: 'initialization' stamp: 'SilverWerewolf 4/29/2020 00:35'!
initialize 
	pagado := 0.! !
